package budgeteer

import (
	"git.javil.eu/jacob1123/budgeteer/postgres"
	"github.com/google/uuid"
)

// Token contains data that authenticates a user
type Token interface {
	GetUsername() string
	GetName() string
	GetExpiry() float64
	GetID() uuid.UUID
}

// TokenVerifier verifies a Token
type TokenVerifier interface {
	VerifyToken(string) (Token, error)
	CreateToken(*postgres.User) (string, error)
}
